#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "jpeglib.h"
#include "jerror.h"
static void error_exit (j_common_ptr cinfo){
    printf("error in jpg\n");
}

static int Bmp2JpegCompress(void* lpBmpBuffer, int nWidth, int nHeight,  void** ppJpegBuffer, unsigned long* pOutSize,char quality)  
{  
    jpeg_compress_struct toWriteInfo;  
    jpeg_error_mgr errorMgr;  
    toWriteInfo.err = jpeg_std_error(&errorMgr);  
    //עʧܵĻص  
    toWriteInfo.err->error_exit = error_exit;  
    jpeg_create_compress(&toWriteInfo);    
    //ȷҪѹjpegݿռ  
    jpeg_mem_dest(&toWriteInfo, (unsigned char**)ppJpegBuffer, pOutSize); 
    toWriteInfo.image_width = nWidth;  
    toWriteInfo.image_height = nHeight;  
    //toWriteInfo.jpeg_width = nWidth / 2;  
    //toWriteInfo.jpeg_height = nHeight / 2;  
    toWriteInfo.input_components = 1;// ڴΪ1,ʾҶͼ ǲɫλͼΪ4  
    toWriteInfo.in_color_space = JCS_GRAYSCALE; //JCS_GRAYSCALEʾҶͼJCS_RGBʾɫͼ   
    jpeg_set_defaults(&toWriteInfo);  
    jpeg_set_quality(&toWriteInfo, quality, TRUE);  //ѹ100ʾ100%  
    jpeg_start_compress(&toWriteInfo, TRUE);  
    int nRowStride = nWidth;  // ͼ,˴Ҫ4  
    JSAMPROW row_pointer[1];    // һλͼ  
    while (toWriteInfo.next_scanline < toWriteInfo.image_height){  
        row_pointer[0] = (JSAMPROW)((unsigned char*)lpBmpBuffer + 
                                     toWriteInfo.next_scanline*nRowStride);  
        jpeg_write_scanlines(&toWriteInfo, row_pointer, 1); 
    }  
    jpeg_finish_compress(&toWriteInfo);  
    jpeg_destroy_compress(&toWriteInfo);  
    return 0;  
}  

extern "C" void savejpg(char * pdata, char *jpg, int width, int height, char quality ){
    char *jpg_file;
    unsigned long size;    
    FILE* fpOut = NULL;
    jpg_file  = (char*)malloc(width*height+4086);
    Bmp2JpegCompress(pdata,  width, height, (void**)&jpg_file, &size,quality);
    fpOut = fopen(jpg, "wb");  
    if (fpOut){  
        fwrite(jpg_file, 1, size, fpOut);  
        fclose(fpOut);  
    }   
    free(jpg_file);    
}

extern "C" int savejpgtobuf(char * pdata, char *jpg, int width, int height, char quality ){
    char *jpg_file;
    unsigned long size;    
    jpg_file  = (char*)malloc(width*height+4086);
    Bmp2JpegCompress(pdata,  width, height, (void**)&jpg_file, &size,quality);
    memcpy(jpg,jpg_file,size);
    free(jpg_file);
    return size;   
}

